/*
 * ak4648.h  --  AK4648 Soc Audio driver
 *
 * Copyright (C) 2011 Renesas Electronics Corporation.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef _AK4648_H
#define _AK4648_H

#define AK4648_VERSION "0.0.1"

#define AK4648_POWER_MANAGEMENT1		0x00
#define AK4648_POWER_MANAGEMENT2		0x01
#define AK4648_SIGNAL_SELECT1			0x02
#define AK4648_SIGNAL_SELECT2			0x03
#define AK4648_MODE_CONTROL1			0x04
#define AK4648_MODE_CONTROL2			0x05
#define AK4648_TIMER_SELECT			0x06
#define AK4648_ALC_MODE_CONTROL1		0x07
#define AK4648_ALC_MODE_CONTROL2		0x08
#define AK4648_LCH_INPUT_VOLUME_CONTROL		0x09
#define AK4648_LCH_DIGITA_VOLUME_CONTROL	0x0a
#define AK4648_ALC_MODE_CONTROL3		0x0b
#define AK4648_RCH_INPUT_VOLUME_CONTROL		0x0c
#define AK4648_RCH_DIGITA_VOLUME_CONTROL	0x0d
#define AK4648_MODE_CONTROL3			0x0e
#define AK4648_MODE_CONTROL4			0x0f
#define AK4648_POWER_MANAGEMENT3		0x10
#define AK4648_DIGITAL_FILTER_SELECT		0x11
#define AK4648_FIL3_COEFFICIENT0		0x12
#define AK4648_FIL3_COEFFICIENT1		0x13
#define AK4648_FIL3_COEFFICIENT2		0x14
#define AK4648_FIL3_COEFFICIENT3		0x15
#define AK4648_EQ_COEFFICIENT0			0x16
#define AK4648_EQ_COEFFICIENT1			0x17
#define AK4648_EQ_COEFFICIENT2			0x18
#define AK4648_EQ_COEFFICIENT3			0x19
#define AK4648_EQ_COEFFICIENT4			0x1a
#define AK4648_EQ_COEFFICIENT5			0x1b
#define AK4648_FIL1_COEFFICIENT0		0x1c
#define AK4648_FIL1_COEFFICIENT1		0x1d
#define AK4648_FIL1_COEFFICIENT2		0x1e
#define AK4648_FIL1_COEFFICIENT3		0x1f
#define AK4648_POWER_MANAGEMENT4		0x20
#define AK4648_MODE_CONTROL5			0x21
#define AK4648_LINEOUT_MIXING_SELECT		0x22
#define AK4648_HP_MIXING_SELECT			0x23
#define AK4648_SPK_MIXING_SELECT		0x24
#define AK4648_EQ_CONTROL_250HZ_100HZ		0x25
#define AK4648_EQ_CONTROL_3500HZ_1KHZ		0x26
#define AK4648_EQ_CONTRO_10KHZ			0x27

#define AK4648_CACHEREGNUM	(AK4648_EQ_CONTRO_10KHZ + 1)


/* AK4648_POWER_MANAGEMENT1 */
#define AK4648_PMSPR	(1 << 7)
#define AK4648_PMVCM	(1 << 6)
#define AK4648_PMMIN	(1 << 5)
#define AK4648_PMSPL	(1 << 4)
#define AK4648_PMLO	(1 << 3)
#define AK4648_PMDAC	(1 << 2)
#define AK4648_PMADL	(1 << 0)


/* AK4648_POWER_MANAGEMENT2 */
#define AK4648_HPMTN	(1 << 6)
#define AK4648_PMHPL	(1 << 5)
#define AK4648_PMHPR	(1 << 4)
#define AK4648_MS	(1 << 3) /* master/slave select */
#define AK4648_MCKO	(1 << 1)
#define AK4648_PMPLL	(1 << 0)

#define PMHP_MASK	(AK4648_PMHPL | AK4648_PMHPR)
#define PMHP		PMHP_MASK


/* AK4648_POWER_MANAGEMENT3 */
#define AK4648_INR1	(1 << 7)
#define AK4648_INL1	(1 << 6)
#define AK4648_MDIF2	(1 << 4)
#define AK4648_MDIF1	(1 << 3)
#define AK4648_INR0	(1 << 2)
#define AK4648_INL0	(1 << 1)
#define AK4648_PMADR	(1 << 0)


/* AK4648_POWER_MANAGEMENT4 */
#define AK4648_PMAINR4	(1 << 7)
#define AK4648_PMAINL4	(1 << 6)
#define AK4648_PMAINR3	(1 << 5)
#define AK4648_PMAINL3	(1 << 4)
#define AK4648_PMAINR2	(1 << 3)
#define AK4648_PMAINL2	(1 << 2)
#define AK4648_PMMICR	(1 << 1)
#define AK4648_PMMICL	(1 << 0)


/* AK4648_SIGNAL_SELECT1 */
#define AK4648_SPPSN	(1 << 7)
#define AK4648_MINS	(1 << 6)
#define AK4648_DACS	(1 << 5)
#define AK4648_DACL	(1 << 4)
#define AK4648_PMMP	(1 << 2)
#define AK4648_MGAIN0	(1 << 0)


/* AK4648_SIGNAL_SELECT2 */
#define AK4648_LOVL	(1 << 7)
#define AK4648_LOPS	(1 << 6)
#define AK4648_MGAIN1	(1 << 5)
#define AK4648_SPKG1	(1 << 4)
#define AK4648_SPKG0	(1 << 3)
#define AK4648_MINL	(1 << 2)
#define AK4648_SPKG2	(1 << 1)


/* AK4648_MODE_CONTROL1 */
#define AK4648_PLL3	(1 << 7)
#define AK4648_PLL2	(1 << 6)
#define AK4648_PLL1	(1 << 5)
#define AK4648_PLL0	(1 << 4)
#define AK4648_BCKO	(1 << 3)
#define AK4648_DIF1	(1 << 1)
#define AK4648_DIF0	(1 << 0)

#define PLL_MASK	(AK4648_PLL3 | AK4648_PLL2 | AK4648_PLL1 | AK4648_PLL0)
#define BCKO_MASK	AK4648_BCKO
#define BCKO_64		BCKO_MASK
#define BCKO_32		0

#define DIF_MASK	(AK4648_DIF1 | AK4648_DIF0)


/* AK4648_MODE_CONTROL2	 */
#define AK4648_PS1	(1 << 7)
#define AK4648_PS0	(1 << 6)
#define AK4648_FS3	(1 << 5)
#define AK4648_MSBS	(1 << 4)
#define AK4648_BCKP	(1 << 4)
#define AK4648_FS2	(1 << 2)
#define AK4648_FS1	(1 << 1)
#define AK4648_FS0	(1 << 0)

#define FS_MASK		(AK4648_FS0 | AK4648_FS1 | AK4648_FS2 | AK4648_FS3)
#define PS_MASK		(AK4648_PS0 | AK4648_PS1)


/* AK4648_MODE_CONTROL3 */
#define AK4648_LOOP	(1 << 6)
#define AK4648_SMUTE	(1 << 5)
#define AK4648_DVOLC	(1 << 4)
#define AK4648_FBEQ	(1 << 2)
#define AK4648_DEM1	(1 << 1)
#define AK4648_DEM0	(1 << 0)

#define DEM_MASK	(AK4648_DEM0 | AK4648_DEM1)


/* AK4648_MODE_CONTROL4 */
#define AK4648_HPG3	(1 << 7)
#define AK4648_HPG2	(1 << 6)
#define AK4648_HPG1	(1 << 5)
#define AK4648_HPG0	(1 << 4)
#define AK4648_IVOLC	(1 << 3)
#define AK4648_HPM	(1 << 2)
#define AK4648_MINH	(1 << 1)
#define AK4648_DACH	(1 << 0)

#define HPG_MASK	(AK4648_HPG0 | AK4648_HPG1 | AK4648_HPG2 | AK4648_HPG3)


/* AK4648_MODE_CONTROL5 */
#define AK4648_SPKMN	(1 << 6)
#define AK4648_MICR3	(1 << 5)
#define AK4648_MICL3	(1 << 4)
#define AK4648_L4DIF	(1 << 3)
#define AK4648_MIX	(1 << 2)
#define AK4648_AIN3	(1 << 1)
#define AK4648_LODIF	(1 << 0)


/* AK4648_TIMER_SELECT */
#define AK4648_DVTM	(1 << 7)
#define AK4648_WTM2	(1 << 6)
#define AK4648_ZTM1	(1 << 5)
#define AK4648_ZTM0	(1 << 4)
#define AK4648_WTM1	(1 << 3)
#define AK4648_WTM0	(1 << 2)
#define AK4648_RFS1	(1 << 1)
#define AK4648_RFS0	(1 << 0)

#define ZTM_MASK	(AK4648_ZTM0 | AK4648_ZTM1)
#define WTM_MASK	(AK4648_WTM0 | AK4648_WTM1 | AK4648_WTM2)
#define RFS_MASK	(AK4648_RFS0 | AK4648_RFS1)


/* AK4648_ALC_MODE_CONTROL1 */
#define AK4648_ALC	(1 << 5)
#define AK4648_ZELMN	(1 << 4)
#define AK4648_LMAT1	(1 << 3)
#define AK4648_LMAT0	(1 << 2)
#define AK4648_RGAIN0	(1 << 1)
#define AK4648_LMTH0	(1 << 0)


/* AK4648_ALC_MODE_CONTROL3 */
#define AK4648_RGAIN1	(1 << 7)
#define AK4648_LMTH1	(1 << 6)
#define AK4648_VBAT	(1 << 1)


/* AK4648_LINEOUT_MIXING_SELECT */
#define AK4648_LOM	(1 << 7)
#define AK4648_LOM3	(1 << 6)
#define AK4648_RINR4	(1 << 5)
#define AK4648_LINL4	(1 << 4)
#define AK4648_RINR3	(1 << 3)
#define AK4648_LINL3	(1 << 2)
#define AK4648_RINR2	(1 << 1)
#define AK4648_LINL2	(1 << 0)


/* AK4648_HP_MIXING_SELECT */
#define AK4648_HPM3	(1 << 6)
#define AK4648_RINH4	(1 << 5)
#define AK4648_LINH4	(1 << 4)
#define AK4648_RINH3	(1 << 3)
#define AK4648_LINH3	(1 << 2)
#define AK4648_RINH2	(1 << 1)
#define AK4648_LINH2	(1 << 0)


/* AK4648_SPK_MIXING_SELECT */
#define AK4648_RINS4	(1 << 5)
#define AK4648_LINS4	(1 << 4)
#define AK4648_RINS3	(1 << 3)
#define AK4648_LINS3	(1 << 2)
#define AK4648_RINS2	(1 << 1)
#define AK4648_LINS2	(1 << 0)


#define AK4648_INPUT_VOL_MAX    241
#define AK4648_OUTPUT_VOL_MAX   255


extern struct snd_soc_dai ak4648_dai;
extern struct snd_soc_codec_device soc_codec_dev_ak4648;

#endif
