/*
 * FIFO-incorporating Melody and Serial Interface (FMSI) support
 *
 * Copyright (C) 2011 Renesas Electronics Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __SOUND_FMSI_SRC_H
#define __SOUND_FMSI_SRC_H



#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_8000
#define SRC_RATIO_INPUT_8000	0x040000
#define SRC_RATIO_INPUT_11025	0x058333
#define SRC_RATIO_INPUT_12000	0x060000
#define SRC_RATIO_INPUT_14700	0x07599A
#define SRC_RATIO_INPUT_16000	0x080000
#define SRC_RATIO_INPUT_22050	0x0B0666
#define SRC_RATIO_INPUT_24000	0x0C0000
#define SRC_RATIO_INPUT_29400	0x0EB333
#define SRC_RATIO_INPUT_32000	0x100000
#define SRC_RATIO_INPUT_44100	0x160CCD
#define SRC_RATIO_INPUT_48000	0x180000
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_8000 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_11025
#define SRC_RATIO_INPUT_8000	0x02E70A
#define SRC_RATIO_INPUT_11025	0x040000
#define SRC_RATIO_INPUT_12000	0x045A8F
#define SRC_RATIO_INPUT_14700	0x055555
#define SRC_RATIO_INPUT_16000	0x05CE14
#define SRC_RATIO_INPUT_22050	0x080000
#define SRC_RATIO_INPUT_24000	0x08B51E
#define SRC_RATIO_INPUT_29400	0x0AAAAB
#define SRC_RATIO_INPUT_32000	0x0B9C27
#define SRC_RATIO_INPUT_44100	0x100000
#define SRC_RATIO_INPUT_48000	0x116A3B
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_11025 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_12000
#define SRC_RATIO_INPUT_8000	0x02AAAB
#define SRC_RATIO_INPUT_11025	0x03ACCD
#define SRC_RATIO_INPUT_12000	0x040000
#define SRC_RATIO_INPUT_14700	0x04E666
#define SRC_RATIO_INPUT_16000	0x055555
#define SRC_RATIO_INPUT_22050	0x07599A
#define SRC_RATIO_INPUT_24000	0x080000
#define SRC_RATIO_INPUT_29400	0x09CCCD
#define SRC_RATIO_INPUT_32000	0x0AAAAB
#define SRC_RATIO_INPUT_44100	0x0EB333
#define SRC_RATIO_INPUT_48000	0x100000
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_12000 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_14700
#define SRC_RATIO_INPUT_8000	0x022D47
#define SRC_RATIO_INPUT_11025	0x030000
#define SRC_RATIO_INPUT_12000	0x0343EB
#define SRC_RATIO_INPUT_14700	0x040000
#define SRC_RATIO_INPUT_16000	0x045A8F
#define SRC_RATIO_INPUT_22050	0x060000
#define SRC_RATIO_INPUT_24000	0x0687D6
#define SRC_RATIO_INPUT_29400	0x080000
#define SRC_RATIO_INPUT_32000	0x08B51E
#define SRC_RATIO_INPUT_44100	0x0C0000
#define SRC_RATIO_INPUT_48000	0x0D0FAC
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_14700 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_16000
#define SRC_RATIO_INPUT_8000	0x020000
#define SRC_RATIO_INPUT_11025	0x02C19A
#define SRC_RATIO_INPUT_12000	0x030000
#define SRC_RATIO_INPUT_14700	0x03ACCD
#define SRC_RATIO_INPUT_16000	0x040000
#define SRC_RATIO_INPUT_22050	0x058333
#define SRC_RATIO_INPUT_24000	0x060000
#define SRC_RATIO_INPUT_29400	0x07599A
#define SRC_RATIO_INPUT_32000	0x080000
#define SRC_RATIO_INPUT_44100	0x0B0666
#define SRC_RATIO_INPUT_48000	0x0C0000
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_16000 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_22050
#define SRC_RATIO_INPUT_8000	0x017385
#define SRC_RATIO_INPUT_11025	0x020000
#define SRC_RATIO_INPUT_12000	0x022D47
#define SRC_RATIO_INPUT_14700	0x02AAAB
#define SRC_RATIO_INPUT_16000	0x02E70A
#define SRC_RATIO_INPUT_22050	0x040000
#define SRC_RATIO_INPUT_24000	0x045A8F
#define SRC_RATIO_INPUT_29400	0x055555
#define SRC_RATIO_INPUT_32000	0x05CE14
#define SRC_RATIO_INPUT_44100	0x080000
#define SRC_RATIO_INPUT_48000	0x08B51E
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_22050 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_24000
#define SRC_RATIO_INPUT_8000	0x015555
#define SRC_RATIO_INPUT_11025	0x01D666
#define SRC_RATIO_INPUT_12000	0x020000
#define SRC_RATIO_INPUT_14700	0x027333
#define SRC_RATIO_INPUT_16000	0x02AAAB
#define SRC_RATIO_INPUT_22050	0x03ACCD
#define SRC_RATIO_INPUT_24000	0x040000
#define SRC_RATIO_INPUT_29400	0x04E666
#define SRC_RATIO_INPUT_32000	0x055555
#define SRC_RATIO_INPUT_44100	0x07599A
#define SRC_RATIO_INPUT_48000	0x080000
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_24000 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_29400
#define SRC_RATIO_INPUT_8000	0x0116A4
#define SRC_RATIO_INPUT_11025	0x018000
#define SRC_RATIO_INPUT_12000	0x01A1F6
#define SRC_RATIO_INPUT_14700	0x020000
#define SRC_RATIO_INPUT_16000	0x022D47
#define SRC_RATIO_INPUT_22050	0x030000
#define SRC_RATIO_INPUT_24000	0x0343EB
#define SRC_RATIO_INPUT_29400	0x040000
#define SRC_RATIO_INPUT_32000	0x045A8F
#define SRC_RATIO_INPUT_44100	0x060000
#define SRC_RATIO_INPUT_48000	0x0687D6
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_29400 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_32000
#define SRC_RATIO_INPUT_8000	0x010000
#define SRC_RATIO_INPUT_11025	0x0160CD
#define SRC_RATIO_INPUT_12000	0x018000
#define SRC_RATIO_INPUT_14700	0x01D666
#define SRC_RATIO_INPUT_16000	0x020000
#define SRC_RATIO_INPUT_22050	0x02C19A
#define SRC_RATIO_INPUT_24000	0x030000
#define SRC_RATIO_INPUT_29400	0x03ACCD
#define SRC_RATIO_INPUT_32000	0x040000
#define SRC_RATIO_INPUT_44100	0x058333
#define SRC_RATIO_INPUT_48000	0x060000
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_32000 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_44100
#define SRC_RATIO_INPUT_8000	0x00B9C2
#define SRC_RATIO_INPUT_11025	0x010000
#define SRC_RATIO_INPUT_12000	0x0116A4
#define SRC_RATIO_INPUT_14700	0x015555
#define SRC_RATIO_INPUT_16000	0x017385
#define SRC_RATIO_INPUT_22050	0x020000
#define SRC_RATIO_INPUT_24000	0x022D47
#define SRC_RATIO_INPUT_29400	0x02AAAB
#define SRC_RATIO_INPUT_32000	0x02E70A
#define SRC_RATIO_INPUT_44100	0x040000
#define SRC_RATIO_INPUT_48000	0x045A8F
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_44100 */

#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_48000
#define SRC_RATIO_INPUT_8000	0x00AAAB
#define SRC_RATIO_INPUT_11025	0x00EB33
#define SRC_RATIO_INPUT_12000	0x010000
#define SRC_RATIO_INPUT_14700	0x01399A
#define SRC_RATIO_INPUT_16000	0x015555
#define SRC_RATIO_INPUT_22050	0x01D666
#define SRC_RATIO_INPUT_24000	0x020000
#define SRC_RATIO_INPUT_29400	0x027333
#define SRC_RATIO_INPUT_32000	0x02AAAB
#define SRC_RATIO_INPUT_44100	0x03ACCD
#define SRC_RATIO_INPUT_48000	0x040000
#endif	/* CONFIG_SND_SOC_SH4_FMSI_SRC_48000 */



#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_8000
#define SRC_INPUT_RATE	8000
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_11025
#define SRC_INPUT_RATE	11025
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_12000
#define SRC_INPUT_RATE	12000
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_14700
#define SRC_INPUT_RATE	14700
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_16000
#define SRC_INPUT_RATE	16000
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_22050
#define SRC_INPUT_RATE	22050
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_24000
#define SRC_INPUT_RATE	24000
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_29400
#define SRC_INPUT_RATE	29400
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_32000
#define SRC_INPUT_RATE	32000
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_44100
#define SRC_INPUT_RATE	44100
#endif
#ifdef CONFIG_SND_SOC_SH4_FMSI_SRC_48000
#define SRC_INPUT_RATE	48000
#endif

#endif /* __SOUND_FMSI_SRC_H */
