/*
 *  File Name       : RSPF0_spu_driver_reg.h
 *  Function        : SPU OPEN SOUND I/F
 *  Release Version : Ver 1.00
 *  Release Date    : 2011/11/30
 *
 *  Copyright (C) 2011 Renesas Electronics Corporation
 *
 *  This program is free software;you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by Free
 *  Softwere Foundation; either version 2 of License, or (at your option) any
 *  later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program;
 *  If not, write to the Free Software Foundation, Inc., 51 Franklin St,
 *  Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef __RSPF0_SPU_DRIVER_REG_H__
#define __RSPF0_SPU_DRIVER_REG_H__

#include <linux/module.h>

#define SPU_DSP_ADDR_OFFSET  (0x00100000)
#define SPU_MEM_PTOP         (0x00000000)
#define SPU_MEM_XTOP         (0x00040000)
#define SPU_MEM_YTOP         (0x00080000)
#define SPU_MEM_IOTOP        (0x000C0000)

/* reg offset */
#define SPU_REG_PBANKC0      (0x000FFC00)
#define SPU_REG_PBANKC1      (0x000FFC04)
#define SPU_REG_PBANKC2      (0x000FFC08)
#define SPU_REG_XBANKC0      (0x000FFC10)
#define SPU_REG_XBANKC1      (0x000FFC14)
#define SPU_REG_XBANKC2      (0x000FFC18)
#define SPU_REG_XBANKS0      (0x000FFC1C)
#define SPU_REG_XBANKS1      (0x000FFC20)
#define SPU_REG_SPUSRST      (0x000FFC24)
#define SPU_REG_SPUADR       (0x000FFC28)

#define SPU_REG_DSPRST       (0x000FFD00)
#define SPU_REG_DSPCORERST   (0x000FFD04)
#define SPU_REG_DSPHOLD      (0x000FFD08)
#define SPU_REG_DSPRESTART   (0x000FFD0C)
#define SPU_REG_IEMASKC      (0x000FFD18)
#define SPU_REG_IMASKC       (0x000FFD1C)
#define SPU_REG_IEVENTC      (0x000FFD20)
#define SPU_REG_IEMASKD      (0x000FFD24)
#define SPU_REG_IMASKD       (0x000FFD28)
#define SPU_REG_IESETD       (0x000FFD2C)
#define SPU_REG_IECLRD       (0x000FFD30)
#define SPU_REG_OR           (0x000FFD34)
#define SPU_REG_COM0         (0x000FFD38)
#define SPU_REG_COM1         (0x000FFD3C)
#define SPU_REG_COM2         (0x000FFD40)
#define SPU_REG_COM3         (0x000FFD44)
#define SPU_REG_COM4         (0x000FFD48)
#define SPU_REG_COM5         (0x000FFD4C)
#define SPU_REG_COM6         (0x000FFD50)
#define SPU_REG_COM7         (0x000FFD54)
#define SPU_REG_SPUSTS       (0x000FFD74)
#define SPU_REG_SBAR0        (0x000FFE00)
#define SPU_REG_SAR0         (0x000FFE04)
#define SPU_REG_DBAR0        (0x000FFE08)
#define SPU_REG_DAR0         (0x000FFE0C)
#define SPU_REG_TCR0         (0x000FFE10)
#define SPU_REG_SHPRI0       (0x000FFE14)
#define SPU_REG_CHCR0        (0x000FFE18)
#define SPU_REG_SBAR1        (0x000FFE20)
#define SPU_REG_SAR1         (0x000FFE24)
#define SPU_REG_DBAR1        (0x000FFE28)
#define SPU_REG_DAR1         (0x000FFE2C)
#define SPU_REG_TCR1         (0x000FFE30)
#define SPU_REG_SHPRI1       (0x000FFE34)
#define SPU_REG_CHCR1        (0x000FFE38)
#define SPU_REG_SBAR2        (0x000FFE40)
#define SPU_REG_SAR2         (0x000FFE44)
#define SPU_REG_DBAR2        (0x000FFE48)
#define SPU_REG_DAR2         (0x000FFE4C)
#define SPU_REG_TCR2         (0x000FFE50)
#define SPU_REG_SHPRI2       (0x000FFE54)
#define SPU_REG_CHCR2        (0x000FFE58)

#endif /* __RSPF0_SPU_DRIVER_REG_H__ */

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("SPU OPEN SOUND I/F Ver 1.0");
MODULE_AUTHOR("Renesas Electronics");
